/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: copyopt.c,v 1.2 2007/05/24 01:26:03 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include "getCGIparm.h"

#define	BADCH	(int)'?'

int
getCGIparmopt( u_int32_t flags
    , u_char * const * const args
    , const u_char * const opts
    , const u_char * const tofind
    , const u_char * const query_delimit
    , const u_char * const null_sign
    , int dout
    ) {
    u_char *a, *p, *q, t[2] = "\0\0";
    const u_char *f1 = NULL, *f2 = NULL;
    int i, j, ex = EX_OK;
    const u_char * const empty = "";
    int out;
    FILE *outf;

    if  (!args || !opts || !query_delimit || !null_sign) return(EX_DATAERR);
    if  ((out = dup(dout)) < 0) {
        ifBLIN_QV1(flags) warn("Can\'t dup out file in getCGIparmopt");
        return(-1);
    }
    if  (!(outf = fdopen(out, "a"))) {
        ifBLIN_QV1(flags) warn("Can\'t open out file in getCGIparmopt");
        return(-1);
    }
    ifBLIN_QV3(flags)
        fprintf( stderr
               , "OP flags=%08X, opts=%s~, tofind=%s~, query_delimit=%s~, null_sign=%s~\n"
               , flags, opts
               , tofind ? tofind : empty
               , query_delimit
               , null_sign
               );
    for (i = 0, j = 0; !ex && (p = args[j]) && *p == '-';) {
        j++;
        ifBLIN_QV4(flags) fprintf(stderr, "p=%s~\n", p);
        if  (*++p == '-') break;
        for (; !ex && *p && (t[0] = *(p++)); i++) {
        ;   ifBLIN_QV4(flags) fprintf(stderr, "  t=%s~\n", t);
        ;   q = NULL;
        ;   f1 = f2 = NULL;
        ;   if  (t[0] == ':' || !(a = strchr(opts, t[0]))) {
        ;       if  (t[0] == '-') { ex = -j; break;}
        ;       if  (~flags & gCGI_EOPT) t[0] = BADCH;
        ;   } else if (*++a == ':') {
        ;       if  (*p) {
        ;           q = p;
        ;           p = (u_char*)empty;
        ;       } else if (args[j]) {
        ;           q = args[j++];
        ;       } else if (~flags & gCGI_EOPT) {
        ;           q = ":";
        ;   }   }
        ;   ifBLIN_QV4(flags) fprintf(stderr, ". t=%s%s%s~\n", t, q ? " q=" : "", q ? q : (u_char*)"");
        ;   if  (q && (ex = getCGIparmpass2(flags, tofind, q)) && ~flags & gCGI_OTST) break;
        ;   f1 = a = t;
        ;   if  (a && (ex = getCGIparmpass3(flags, "copy", &a))) break;
        ;   f2 = q;
        ;   if  (q && (ex = getCGIparmpass3(flags, "copy", &q))) break;
        ;   if  (flags & gCGI_RNUM) fprintf(outf, "%d%s", i, query_delimit);
        ;   fprintf(outf, "%s%s", a ? a : null_sign, query_delimit);
        ;   fprintf(outf, "%s\n", q ? q : null_sign);
        ;   if  (a && f1 && a != f1) { free(a); a = NULL;}
        ;   if  (q && f2 && q != f2) { free(q); q = NULL;}
        }
        if  (a && f1 && a != f1) { free(a); a = NULL;}
        if  (q && f2 && q != f2) { free(q); q = NULL;}
    }
    if  (ex <= 0) fprintf(outf, "\\.\n");
    ifBLIN_QV3(flags) fprintf(stderr, "OP ex=%d j=%d\n", ex, j);
    fclose(outf);
    return(ex ? ex : -j);
}
